; 
    .586                       ; create 32 bit code
    .model flat, stdcall       ; 32 bit memory model
    option casemap :none       ; case sensitive
    .MMX
 
    include \masm32\include\windows.inc
    include \masm32\include\masm32.inc
    include \masm32\include\user32.inc
    include \masm32\include\kernel32.inc
    includelib \masm32\lib\masm32.lib
    includelib \masm32\lib\kernel32.lib
    includelib \masm32\lib\user32.lib
    include \masm32\macros\macros.asm
    include timers.asm

    _EMMS equ 1
; 
    .data
        aligned_mmx64     dd 0,0
        aligned_real8     REAL8 0.0
        aligned_mmx32     dd 0
        aligned_real4     REAL4 0.0
        aligned_dword     dd 0
        aligned_word      dw 0
        db 0              ; misalign by 1 byte
        misaligned_mmx64  dd 0,0
        misaligned_real8  REAL8 0.0
        misaligned_mmx32  dd 0
        misaligned_real4  REAL4 0.0
        misaligned_dword  dd 0
        dw 0              ; misalign across dword boundary
        misaligned_word   dw 0
    .code
; 
start: 
; 
    LOOP_COUNT    EQU 10000000
    REPEAT_COUNT  EQU 100

    counter_begin LOOP_COUNT,HIGH_PRIORITY_CLASS
      mov   eax,OFFSET aligned_mmx64
      REPEAT REPEAT_COUNT
        movq  mm0,[eax]
        movq  [eax],mm0
      ENDM
    counter_end
    mov   ebx,eax
    print chr$("aligned_mmx64    : ")
    print ustr$(ebx)
    print chr$(" cycles",13,10)

    counter_begin LOOP_COUNT,HIGH_PRIORITY_CLASS
      REPEAT REPEAT_COUNT
        fld   aligned_real8
        fstp  aligned_real8
      ENDM
    counter_end
    mov   ebx,eax
    print chr$("aligned_real8    : ")
    print ustr$(ebx)
    print chr$(" cycles",13,10)

    counter_begin LOOP_COUNT,HIGH_PRIORITY_CLASS
      mov   eax,OFFSET aligned_mmx32
      REPEAT REPEAT_COUNT
        movd  mm0,[eax]
        movd  [eax],mm0
      ENDM
    counter_end
    mov   ebx,eax
    print chr$("aligned_mmx32    : ")
    print ustr$(ebx)
    print chr$(" cycles",13,10)

    counter_begin LOOP_COUNT,HIGH_PRIORITY_CLASS
      REPEAT REPEAT_COUNT
        fld   aligned_real4
        fstp  aligned_real4
      ENDM
    counter_end
    mov   ebx,eax
    print chr$("aligned_real4    : ")
    print ustr$(ebx)
    print chr$(" cycles",13,10)

    counter_begin LOOP_COUNT,HIGH_PRIORITY_CLASS
      REPEAT REPEAT_COUNT
        mov   eax,aligned_dword
        mov   aligned_dword,eax
      ENDM
    counter_end
    mov   ebx,eax
    print chr$("aligned_dword    : ")
    print ustr$(ebx)
    print chr$(" cycles",13,10)

    counter_begin LOOP_COUNT,HIGH_PRIORITY_CLASS
      REPEAT REPEAT_COUNT
        mov   ax,aligned_word
        mov   aligned_word,ax
      ENDM
    counter_end
    mov   ebx,eax
    print chr$("aligned_word     : ")
    print ustr$(ebx)
    print chr$(" cycles",13,10)

    counter_begin LOOP_COUNT,HIGH_PRIORITY_CLASS
      mov   eax,OFFSET misaligned_mmx64
      REPEAT REPEAT_COUNT
        movq  mm0,[eax]
        movq  [eax],mm0
      ENDM
    counter_end
    mov   ebx,eax
    print chr$("misaligned_mmx64 : ")
    print ustr$(ebx)
    print chr$(" cycles",13,10)

    counter_begin LOOP_COUNT,HIGH_PRIORITY_CLASS
      REPEAT REPEAT_COUNT
        fld   misaligned_real8
        fstp  misaligned_real8
      ENDM
    counter_end
    mov   ebx,eax
    print chr$("misaligned_real8 : ")
    print ustr$(ebx)
    print chr$(" cycles",13,10)

    counter_begin LOOP_COUNT,HIGH_PRIORITY_CLASS
      mov   eax,OFFSET misaligned_mmx32
      REPEAT REPEAT_COUNT
        movd  mm0,[eax]
        movd  [eax],mm0
      ENDM
    counter_end
    mov   ebx,eax
    print chr$("misaligned_mmx32 : ")
    print ustr$(ebx)
    print chr$(" cycles",13,10)

    counter_begin LOOP_COUNT,HIGH_PRIORITY_CLASS
      REPEAT REPEAT_COUNT
        fld   misaligned_real4
        fstp  misaligned_real4
      ENDM
    counter_end
    mov   ebx,eax
    print chr$("misaligned_real4 : ")
    print ustr$(ebx)
    print chr$(" cycles",13,10)

    counter_begin LOOP_COUNT,HIGH_PRIORITY_CLASS
      REPEAT REPEAT_COUNT
        mov   eax,misaligned_dword
        mov   misaligned_dword,eax
      ENDM
    counter_end
    mov   ebx,eax
    print chr$("misaligned_dword : ")
    print ustr$(ebx)
    print chr$(" cycles",13,10)

    counter_begin LOOP_COUNT,HIGH_PRIORITY_CLASS
      REPEAT REPEAT_COUNT
        mov   ax,misaligned_word
        mov   misaligned_word,ax
      ENDM
    counter_end
    mov   ebx,eax
    print chr$("misaligned_word  : ")
    print ustr$(ebx)
    print chr$(" cycles",13,10)

    mov   eax, input(13,10,"Press enter to exit...")
    exit
; 
end start
